;**************************************************************************
;* HASM64                                                                 *
;**************************************************************************

;**************************************************************************
;* File name:     opcodes.asm                                             *
;* Created:       2001-06-01 by Hampa Hug <hhug@student.ethz.ch>          *
;* Last modified: 2001-06-02 by Hampa Hug <hhug@student.ethz.ch>          *
;* Copyright:     (C) 1997-2001 by Hampa Hug <hhug@student.ethz.ch>       *
;**************************************************************************

;**************************************************************************
;* This program is free software; you can redistribute it and/or modify   *
;* it under the terms of the GNU General Public License as published by   *
;* the Free Software Foundation; either version 2 of the License, or      *
;* (at your option) any later version.                                    *
;**************************************************************************/

module opcodes = 2047

op_adc:
  adc    0x55
  adc    [0xaa]
  adc    [0xaaaa]
  adc    [0xaa + x]
  adc    [0xaaaa + x]
  adc    [0xaaaa + y]
  adc    [[0xaa] + y]
  adc    [[0xaa + x]]

op_and:
  and    0x55
  and    [0xaa]
  and    [0xaaaa]
  and    [0xaa + x]
  and    [0xaaaa + x]
  and    [0xaaaa + y]
  and    [[0xaa] + y]
  and    [[0xaa + x]]

op_asl:
  asl    a
  asl    [0xaa]
  asl    [0xaaaa]
  asl    [0xaa + x]
  asl    [0xaaaa + x]

op_bra:
  bcc    op_bra
  bcs    op_bra
  beq    op_bra
  bne    op_bra
  bpl    op_bra
  bmi    op_bra
  bvc    op_bra
  bvs    op_bra

op_brk:
  brk

op_bit:
  bit    [0xaa]
  bit    [0xaaaa]

op_clc:
  clc

op_cld:
  cld

op_cli:
  cli

op_clv:
  clv

op_cmp:
  cmp    0x55
  cmp    [0xaa]
  cmp    [0xaaaa]
  cmp    [0xaa + x]
  cmp    [0xaaaa + x]
  cmp    [0xaaaa + y]
  cmp    [[0xaa] + y]
  cmp    [[0xaa + x]]

op_cpx:
  cpx    0x55
  cpx    [0xaa]
  cpx    [0xaaaa]

op_cpy:
  cpy    0x55
  cpy    [0xaa]
  cpy    [0xaaaa]

op_dec:
  dec    [0xaa]
  dec    [0xaaaa]
  dec    [0xaa + x]
  dec    [0xaaaa + x]

op_dex:
  dex

op_dey:
  dey

op_eor:
  eor    0x55
  eor    [0xaa]
  eor    [0xaaaa]
  eor    [0xaa + x]
  eor    [0xaaaa + x]
  eor    [0xaaaa + y]
  eor    [[0xaa] + y]
  eor    [[0xaa + x]]

op_inc:
  inc    [0xaa]
  inc    [0xaaaa]
  inc    [0xaa + x]
  inc    [0xaaaa + x]

op_inx:
  inx

op_iny:
  iny

op_jmp:
  jmp    op_jmp
  jmp    [op_jmp]

op_jsr:
  jsr    op_jsr

op_lda:
  lda    0x55
  lda    [0xaa]
  lda    [0xaaaa]
  lda    [0xaa + x]
  lda    [0xaaaa + x]
  lda    [0xaaaa + y]
  lda    [[0xaa] + y]
  lda    [[0xaa + x]]

op_ldx:
  ldx    0x55
  ldx    [0xaa]
  ldx    [0xaaaa]
  ldx    [0xaa + y]
  ldx    [0xaaaa + y]

op_ldy:
  ldy    0x55
  ldy    [0xaa]
  ldy    [0xaaaa]
  ldy    [0xaa + x]
  ldy    [0xaaaa + x]

op_lsr:
  lsr    a
  lsr    [0xaa]
  lsr    [0xaaaa]
  lsr    [0xaa + x]
  lsr    [0xaaaa + x]

op_nop:
  nop

op_ora:
  ora    0x55
  ora    [0xaa]
  ora    [0xaaaa]
  ora    [0xaa + x]
  ora    [0xaaaa + x]
  ora    [0xaaaa + y]
  ora    [[0xaa] + y]
  ora    [[0xaa + x]]

op_pha:
  pha

op_php:
  php

op_pla:
  pla

op_plp:
  plp

op_rol:
  rol    a
  rol    [0xaa]
  rol    [0xaaaa]
  rol    [0xaa + x]

op_ror:
  ror    a
  ror    [0xaa]
  ror    [0xaaaa]
  ror    [0xaa + x]

op_rti:
  rti

op_rts:
  rts

op_sbc:
  sbc    0x55
  sbc    [0xaa]
  sbc    [0xaaaa]
  sbc    [0xaa + x]
  sbc    [0xaaaa + x]
  sbc    [0xaaaa + y]
  sbc    [[0xaa] + y]
  sbc    [[0xaa + x]]

op_sec:
  sec

op_sed:
  sed

op_sei:
  sei

op_sta:
  sta    [0xaa]
  sta    [0xaaaa]
  sta    [0xaa + x]
  sta    [0xaaaa + x]
  sta    [0xaaaa + y]
  sta    [[0xaa] + y]
  sta    [[0xaa + x]]

op_stx:
  stx    [0xaa]
  stx    [0xaaaa]
  stx    [0xaa + y]

op_sty:
  sty    [0xaa]
  sty    [0xaaaa]
  sty    [0xaa + x]

op_tax:
  tax

op_tay:
  tay

op_tsx:
  tsx

op_txa:
  txa

op_txs:
  txs

op_tya:
  tya

end
