;**************************************************************************
;* HASM64                                                                 *
;**************************************************************************

;**************************************************************************
;* File name:     sprite.asm                                              *
;* Created:       2001-06-02 by Hampa Hug <hhug@student.ethz.ch>          *
;* Last modified: 2001-06-02 by Hampa Hug <hhug@student.ethz.ch>          *
;* Copyright:     (C) 1997-2001 by Hampa Hug <hhug@student.ethz.ch>       *
;**************************************************************************

;**************************************************************************
;* This program is free software; you can redistribute it and/or modify   *
;* it under the terms of the GNU General Public License as published by   *
;* the Free Software Foundation; either version 2 of the License, or      *
;* (at your option) any later version.                                    *
;**************************************************************************/

module sprite_demo = 2047


include "startup.inc"


start:
  ldx    sprite_end - sprite - 1

next_byte:
  lda    [sprite + x]
  sta    [0x0340 + x]
  dex
  bpl    next_byte

  lda    0x0d
  sta    [0x07f8]                      ; Sprite 0 pointer

  lda    0
  sta    [0xd000]                      ; Sprite 0 x
  sta    [0xd001]                      ; Sprite 0 y

  lda    [0xd010]
  and    ~1
  sta    [0xd010]                      ; Sprite x MSB

  lda    0x01
  sta    [0xd015]                      ; Sprite enable

  lda    0x00
  sta    [0xd01c]                      ; Sprite multicolor select

  ldx    (185 - 12) - 5
  ldy    51 - 21

next:
  stx    [0xd000]                      ; Sprite 0 x
  sty    [0xd001]                      ; Sprite 0 y

raster_0:
  lda    [0xd011]
  and    0x80
  ora    [0xd012]
  beq    raster_0

raster_not_0:
  lda    [0xd011]
  and    0x80
  ora    [0xd012]
  bne    raster_not_0

  iny
  cpy    251
  bcc    next

  ldy    51 - 21

  inx
  inx
  cpx    (185 - 12) + 6
  bcc    next

  rts

sprite:
  db     0x00, 0x7f, 0x00
  db     0x01, 0xff, 0xc0
  db     0x03, 0xff, 0xe0
  db     0x03, 0xe3, 0xe0
  db     0x07, 0xd9, 0xf0
  db     0x07, 0xdf, 0xf0
  db     0x07, 0xd9, 0xf0
  db     0x03, 0xe7, 0xe0
  db     0x03, 0xff, 0xe0
  db     0x03, 0xff, 0xe0
  db     0x02, 0xff, 0xa0
  db     0x01, 0x7f, 0x40
  db     0x01, 0x3e, 0x40
  db     0x00, 0x9c, 0x80
  db     0x00, 0x9c, 0x80
  db     0x00, 0x49, 0x00
  db     0x00, 0x49, 0x00
  db     0x00, 0x3e, 0x00
  db     0x00, 0x3e, 0x00
  db     0x00, 0x3e, 0x00
  db     0x00, 0x1c, 0x00
sprite_end:

end
