/**************************************************************************
 * HASM64                                                                 *
 **************************************************************************/

/**************************************************************************
 * File name:     expr.h                                                  *
 * Created:       2001-05-30 by Hampa Hug <hhug@student.ethz.ch>          *
 * Last modified: 2001-06-03 by Hampa Hug <hhug@student.ethz.ch>          *
 * Copyright:     (C) 1997-2001 by Hampa Hug <hhug@student.ethz.ch>       *
 **************************************************************************/

/**************************************************************************
 * This program is free software; you can redistribute it and/or modify   *
 * it under the terms of the GNU General Public License as published by   *
 * the Free Software Foundation; either version 2 of the License, or      *
 * (at your option) any later version.                                    *
 **************************************************************************/

#ifndef HASM64_EXPR_H
#define HASM64_EXPR_H


typedef struct s_sumxy_t {
  struct s_sumxy_t *ind;
  unsigned         val;
  unsigned         x;
  unsigned         y;
} sumxy_t;


int par_exp_val (parser_t *par, unsigned *val);

/*!************************************************************************
 * Parse an expression. The result is returned as 16 bit unsigned
 * integer in val.
 * Returns 0 on success.
 **************************************************************************/
int par_exp (parser_t *par, unsigned *val);

sumxy_t *sumxy_new (void);
void sumxy_del (sumxy_t *sum);
int sumxy_check (sumxy_t *sum);
sumxy_t *par_exp_xy_sum (parser_t *par);
sumxy_t *par_exp_xy (parser_t *par);


#endif
