/**************************************************************************
 * HASM64                                                                 *
 **************************************************************************/

/**************************************************************************
 * File name:     hdisasm64.h                                             *
 * Created:       2001-06-01 by Hampa Hug <hhug@student.ethz.ch>          *
 * Last modified: 2001-06-03 by Hampa Hug <hhug@student.ethz.ch>          *
 * Copyright:     (C) 1997-2001 by Hampa Hug <hhug@student.ethz.ch>       *
 **************************************************************************/

/**************************************************************************
 * This program is free software; you can redistribute it and/or modify   *
 * it under the terms of the GNU General Public License as published by   *
 * the Free Software Foundation; either version 2 of the License, or      *
 * (at your option) any later version.                                    *
 **************************************************************************/

#ifndef HDASM64_H
#define HDASM64_H


#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define prt_msg(str) fprintf (stderr, str); fflush (stderr);
#define prt_msg_1(str, v1) fprintf (stderr, str, v1); fflush (stderr);
#define prt_msg_2(str, v1, v2) fprintf (stderr, str, v1, v2); fflush (stderr);

#define prtv_msg(str) if (h64_verbose) { prt_msg (str); }
#define prtv_msg_1(str, v1) if (h64_verbose) { prt_msg_1 (str, v1); }
#define prtv_msg_2(str, v1, v2) if (h64_verbose) { prt_msg_2 (str, v2); }


char *str_clone (char *str);


#define M_IMP   0
#define M_ACC   1
#define M_IMM   2
#define M_ZPG   3
#define M_ABS   4
#define M_ZPG_X 5
#define M_ABS_X 6
#define M_ZPG_Y 7
#define M_ABS_Y 8
#define M_IND_X 9
#define M_IND_Y 10
#define M_REL   11
#define M_IMM16 12


typedef struct {
  unsigned op;
  char     *instr;
  unsigned cnt;
  unsigned mode;
} op_tab_t;

typedef struct {
  unsigned      addr;

  unsigned      cnt;
  unsigned char data[4];

  char          op[256];
  char          par[256];
} instr_t;


#endif
